#sendSMS
#Using tip-top-sms.ru SMS service (for 3 free SMS)
#By Kissa2k

package sendSMS;

use strict;
use IO::Socket;
use Plugins;
use Commands;
use Globals;
use Utils;
use Log qw(message error warning);

Plugins::register('sendSMS', 'Send SMS messages.', \&Unload, \&Unload);

my $hook = Commands::register(
    ['sms','Send SMS messages.',\&sms]
);

sub Unload {
	Commands::unregister($hook);
}

sub trim {
    my($string)=@_;
    for ($string) {
        s/^\s+//;
        s/\s+$//;
        }
    return $string;
}

sub sms {
	my (undef, $args) = @_;
	my @args = split(/ /, $args);
	
	my $sent = 0;
	my $message;
	my $sock;
	my $data;
	my $cookie;
	
	$data = "username=".$config{'sendSMS_0_username'}."&pass_from_php=".$config{'sendSMS_0_password'}."&submit=%C2%EE%E9%F2%E8";
	
	if($args[0]){
	
		for(my $i=0; $i <= @args; $i++){
			$message .= $args[$i]." ";
		}
		$message = trim($message);
		$message = urlencode($message);
		
		if(length($message) >= 140){
			message("[sendSMS] Your message is too large.\n", "info");
			return;
		}
	
		#   ..
		while(!$sock){
			$sock = new IO::Socket::INET(
				PeerAddr => 'tip-top-sms.ru',
				PeerPort => '80',
				Proto => 'tcp');
		}
		
		print $sock "POST /index.php HTTP/1.1\r\n";
		print $sock "Host: tip-top-sms.ru\r\n";
		print $sock "User-Agent: $Settings::NAME $Settings::VERSION($Settings::NAME)\r\n";
		print $sock "Accept: */*\r\n";
		print $sock "Accept-Language: en-us,en\r\n";
		print $sock "Connection: close\r\n";
		print $sock "Referer: http://tip-top-sms.ru\r\n";
		print $sock "Content-Type: application/x-www-form-urlencoded\r\n";
		print $sock "Content-Length: ".length($data)."\r\n";
		print $sock "\r\n";
		print $sock $data;
		
		while(<$sock>){
			$cookie = $1 if($_ =~ m/Set-Cookie: ([\d\w=]+); path=\//);
		}
		
		close($sock);
		undef $sock;
		
		# ..
		while(!$sock){
			$sock = new IO::Socket::INET(
				PeerAddr => 'tip-top-sms.ru',
				PeerPort => '80',
				Proto => 'tcp');
		}
		
		print $sock "GET /index.php?ch=halyava_sms2&sender_name=&number=".$config{'sendSMS_0_number'}."&text_sms=".$message."&tbLen=".length($message)."&lblMax=143&submit=%CE%F2%EE%F1%EB%E0%F2%FC HTTP/1.1\r\n";
		print $sock "Host: tip-top-sms.ru\r\n";
		print $sock "User-Agent: $Settings::NAME $Settings::VERSION($Settings::NAME)\r\n";
		print $sock "Accept: */*\r\n";
		print $sock "Accept-Language: en-us,en\r\n";
		print $sock "Connection: close\r\n";
		print $sock "Referer: http://tip-top-sms.ru/index.php?ch=halyava_sms\r\n";
		print $sock "Cookie: ".$cookie."; hotlog=1\r\n";
		print $sock "\r\n";

		while(<$sock>){
			$sent = 1 if($_ =~ m/-   (\d+)  /); 
		}
		
		if($sent){
			message("[sendSMS] Your SMS has been successfully sent.\n");
		}else{
			error("[sendSMS] Failed to send SMS.\n");
		}
		
		close($sock);
	}else{
		error("[sendSMS] Syntax Error in function 'sms'\nUsage: sms < message >\nWhere < message > is your SMS message.\n");	
	}
}

return 1;
